/*********************************************************************

This has been proposed by an exercise by Rustan Leino during the
Marktoberdorf Summer School in 2011.

Given a 2-dimensional array where the values along any row or any
column are non-decreasing, and given a value "s" in the array, find
an index "x,y" such that s == array[x,y].

The runtime had to be linear in the array dimension, i.e. O(max(n,m))
for an array of dimension n*m.

Tasks:
  - Find the algorithm which performs the task and think about the
    loop invariant which guarantees correctness.
  ONLY THEN:
  - Complete the implementation (E)
  - First find suitable preconditions expressions (A), (B)
  - Find a suitable decreases clause and a loop invariant strong 
    enough to prove absence of runtime exceptions
  - Find a strong enough loop invariant which proves (D)
    (That is the easy case)
  - Express the postcondition of (C)
  - Strengthen the loop invariant such that it entails (C).

*********************************************************************/

class Saddleback {

    /*@ public normal_behaviour
      @
      @ // all rows have same number of entries
      @ requires (\forall int i; 0<=i && i<array.length; 
      @     array[i].length == array[0].length);
      @
      @ // array is not empty in any dimension
      @ requires array.length > 0;
      @ requires array[0].length > 0;
      @
      @ requires true; // TO DO: rows are sorted (A)
      @ 
      @ requires true; // TO DO: columns are sorted (B)
      @
      @ ensures \result == null ==> true; // TO DO: value not present in array (C)
      @
      @ ensures \result != null ==>     // (D)
      @     \result.length == 2 &&
      @     array[\result[0]][\result[1]] == value;
      @ 
      @ modifies \nothing;
      @*/

    public /*@nullable*/ int[] search(int[][] array, int value) {
        int x = 0;
        int y = array[0].length - 1;

        /*@
          @ loop_invariant true;
          @    // TO DO
          @
          @ decreases 0;  // TO DO
          @
          @ modifies \nothing;
          @*/
	while(x < array.length && y >= 0) {

            if(array[x][y] == value) {
                return new int[] { x, y };
            }

            // TO DO: process indices; (E)

        }

        return null;
    }
}

